@make(ais)
@aiInfo(topic=<Static numeric subtypes>,
number=[AI-00023/06],
classcode=[BI],
statuscode=[WJ],
mainref=[04.09@\(11)],
date=[86-07-23])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
@standard[03.05.04@\(04)]
@standard[03.05.07@\(10)]
@standard[03.05.09@\(08)]
!class binding interpretation 83-10-18
!status approved by WG9/AJPO 86-07-22
@end(toplines)
!status approved by Director, AJPO 86-07-22
!status approved by WG9/Ada Board 86-07-22
!status approved by Ada Board 86-07-22
!status approved by WG9/ADA Board 85-02-26
!status board-approved 84-06-29
!status committee-approved 84-02-06
!status work-item 83-10-10
@references[!references @CommentNum[83-00073]83-00073, @CommentNum[83-00202]83-00202, @CommentNum[83-00250]83-00250, @CommentNum[83-00315]83-00315]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 84-03-14]

Declarations containing integer and real type definitions declare static
subtypes, e.g., given
@begin(example)
@key[type] T @key[is] @key[range] 1..10;
@end(example)
T is a static subtype.

@subheading[!question 84-07-13]

The wording of 3.5.4(4) seems to indicate that given the declaration
@begin(example)
@key[type] T @key[is] @key[range] 1..10;
@end(example)
T is not a static subtype, since conversions of static expressions are not
static.  Similar wording applies to the declaration of fixed and floating
point types.  Are all numeric types non-static?

@subheading[!recommendation 83-10-30]

It is the intent that an integer type declared with an integer type definition
be considered static, and similarly, a real type declared with a real type
definition should be considered static.  The
equivalence stated in 3.5.4(4), 3.5.7(10), and 3.5.9(8) should not be taken
literally for purposes of defining whether the declared type is static.

@subheading[!discussion 84-03-14]

By 3.5.4(4), the declaration
@begin(example)
@key[type] T @key[is] @key[range] 1..10;
@end(example)
is equivalent to
@begin(example)
@key[type] integer_@|type @key[is] @key[new] predefined_@|integer_@|type;
@key[subtype] T @key[is] integer_@|type
    @key[range] integer_@|type(1) .. integer_@|type(10);
@end(example)
and, by 4.9, type conversions are not static.  Hence, T is not a static
subtype.  Similar equivalences are defined for floating point and fixed point
type declarations [3.5.7(10); 3.5.9(8)].  Interpreting these equivalences
literally would imply that no user-defined integer or real subtype is static.
4.9(11), however, implies that real subtypes can be static by mentioning
floating and fixed point constraints in association with the definition of
scalar static subtypes.  (Moreover, Ada comment #3077 shows that numeric types
were intended to be static.)

The intent of the Standard is, therefore, that a subtype declared with an
integer or real type definition be considered static, and that the
equivalences stated in 3.5.4(4), 3.5.7(10) and 3.5.9(8) not be taken literally
for purposes of defining whether the declared subtype is static.

